org.apache.ignite

## Class IgniteSystemProperties

- java.lang.Object
- - org.apache.ignite.IgniteSystemProperties

    public final class IgniteSystemProperties
    extends Object

Contains constants for all system properties and environmental variables in Ignite. These properties and variables can be used to affect the behavior of Ignite.

### Field Summary

Fields
`static String` `IGNITE_AFFINITY_HISTORY_SIZE` Maximum size for affinity assignment history.
`static String` `IGNITE_ATOMIC_CACHE_DELETE_HISTORY_SIZE` Maximum size for atomic cache queue delete history (default is 200 000 entries per partition).
`static String` `IGNITE_ATOMIC_CACHE_MAX_CONCURRENT_DHT_UPDATES` Maximum amount of concurrent updates per system thread in atomic caches in case of PRIMARY_SYNC or FULL_ASYNC write synchronization mode.
`static String` `IGNITE_ATOMIC_DEFERRED_ACK_BUFFER_SIZE` Atomic cache deferred update response buffer size.
`static String` `IGNITE_ATOMIC_DEFERRED_ACK_TIMEOUT` Atomic cache deferred update timeout.
`static String` `IGNITE_BINARY_DONT_WRAP_TREE_STRUCTURES` Deprecated. Should be removed in Apache Ignite 2.0.
`static String` `IGNITE_BINARY_MARSHALLER_USE_STRING_SERIALIZATION_VER_2` Manages type of serialization mechanism for `String` that is marshalled/unmarshalled by BinaryMarshaller.
`static String` `IGNITE_BINARY_SORT_OBJECT_FIELDS` Deprecated. Should be removed in Apache Ignite 2.0.
`static String` `IGNITE_CACHE_CLIENT` Property controlling default behavior of cache client flag.
`static String` `IGNITE_CACHE_KEY_VALIDATION_DISABLED` Flag indicating whether validation of keys put to cache should be disabled.
`static String` `IGNITE_CACHE_REMOVED_ENTRIES_TTL` Ttl of removed cache entries (ms).
`static String` `IGNITE_CACHE_RETRIES_COUNT` Number of cache operation retries in case of topology exceptions.
`static String` `IGNITE_CACHE_START_SIZE` Cache start size for on-heap maps.
`static String` `IGNITE_CONFIG_URL` System property to hold optional configuration URL.
`static String` `IGNITE_CONSISTENT_ID_BY_HOST_WITHOUT_PORT` When set to `true`, for consistent id will calculate by host name, without port, and you can use only one node for host in cluster.
`static String` `IGNITE_CONSOLE_APPENDER` If this property is set to `true` (default) and Ignite is launched in verbose mode (see `IGNITE_QUIET`) and no console appenders can be found in configuration, then default console appender will be added.
`static String` `IGNITE_DAEMON` Presence of this system property with value `true` will make the grid node start as a daemon node.
`static String` `IGNITE_DEFERRED_ONE_PHASE_COMMIT_ACK_REQUEST_BUFFER_SIZE` One phase commit deferred ack request buffer size.
`static String` `IGNITE_DEFERRED_ONE_PHASE_COMMIT_ACK_REQUEST_TIMEOUT` One phase commit deferred ack request timeout.
`static String` `IGNITE_DEP_MODE_OVERRIDE` System property to override deployment mode configuration parameter.
`static String` `IGNITE_DISABLE_HOSTNAME_VERIFIER` System property to disable `HostnameVerifier` for SSL connections.
`static String` `IGNITE_DISCO_FAILED_CLIENT_RECONNECT_DELAY` Defines reconnect delay in milliseconds for client node that was failed forcible.
`static String` `IGNITE_DISCOVERY_CLIENT_RECONNECT_HISTORY_SIZE` Maximum number of discovery message history used to support client reconnect.
`static String` `IGNITE_DISCOVERY_HISTORY_SIZE` Maximum size for discovery messages history.
`static String` `IGNITE_DUMP_PENDING_OBJECTS_THRESHOLD` Number of times pending cache objects will be dumped to the log in case of partition exchange timeout.
`static String` `IGNITE_EXCEPTION_REGISTRY_MAX_SIZE` Property controlling size of buffer holding last exception.
`static String` `IGNITE_H2_DEBUG_CONSOLE` If this property set then debug console will be opened for H2 indexing SPI.
`static String` `IGNITE_H2_DEBUG_CONSOLE_PORT` This property allows to specify user defined port which H2 indexing SPI will use to start H2 debug console on.
`static String` `IGNITE_H2_INDEXING_CACHE_CLEANUP_PERIOD` System property to specify period in milliseconds between calls of the SQL statements cache cleanup task.
`static String` `IGNITE_H2_INDEXING_CACHE_THREAD_USAGE_TIMEOUT` System property to specify timeout in milliseconds after which thread's SQL statements cache is cleared by cleanup task if the thread does not perform any query.
`static String` `IGNITE_HOME` Defines Ignite installation folder.
`static String` `IGNITE_INDEXING_DISCOVERY_HISTORY_SIZE` Indexing discovery history size.
`static String` `IGNITE_IO_BALANCE_PERIOD`
`static String` `IGNITE_IPC_SHMEM_SPACE_DEBUG` If this property is set to `true` then shared memory space native debug will be enabled.
`static String` `IGNITE_JCACHE_DEFAULT_ISOLATED` Property controlling whether CacheManager will start grid with isolated IP finder when default URL is passed in.
`static String` `IGNITE_JDBC_DRIVER_CURSOR_REMOVE_DELAY` JDBC driver cursor remove delay.
`static String` `IGNITE_JETTY_HOST` This property allows to override Jetty host for REST processor.
`static String` `IGNITE_JETTY_LOG_NO_OVERRIDE` This property does not allow Ignite to override Jetty log configuration for REST processor.
`static String` `IGNITE_JETTY_PORT` This property allows to override Jetty local port for REST processor.
`static String` `IGNITE_JOBS_HISTORY_SIZE` System property to override default job processor maps sizes for finished jobs and cancellation requests.
`static String` `IGNITE_JOBS_METRICS_CONCURRENCY_LEVEL` System property to override default job metrics processor property defining concurrency level for structure holding job metrics snapshots.
`static String` `IGNITE_LOCAL_HOST` Name of system property to set system-wide local IP address or host.
`static String` `IGNITE_LOCAL_STORE_KEEPS_PRIMARY_ONLY` Indicating whether local store keeps primary only.
`static String` `IGNITE_LOG_DIR` Environment variable to override logging directory that has been set in logger configuration.
`static String` `IGNITE_LOG_GRID_NAME` Deprecated. Use `IGNITE_LOG_INSTANCE_NAME`.
`static String` `IGNITE_LOG_INSTANCE_NAME` If this system property is present the Ignite will include instance name into verbose log.
`static String` `IGNITE_LONG_LONG_HASH_MAP_LOAD_FACTOR` Long-long offheap map load factor.
`static String` `IGNITE_LONG_OPERATIONS_DUMP_TIMEOUT` Cache operations that take more time than value of this property will be output to log.
`static String` `IGNITE_MAP_CONCURRENCY_LEVEL` Concurrency level for all concurrent hash maps created by Ignite.
`static String` `IGNITE_MARSHAL_BUFFERS_RECHECK` System property to specify how often in milliseconds marshal buffers should be rechecked and potentially trimmed.
`static String` `IGNITE_MAX_COMPLETED_TX_COUNT` Property controlling size of buffer holding completed transaction versions.
`static String` `IGNITE_MAX_INDEX_PAYLOAD_SIZE` System property to specify maximum payload size in bytes for `H2TreeIndex`.
`static String` `IGNITE_MAX_NESTED_LISTENER_CALLS` Maximum number of nested listener calls before listener notification becomes asynchronous.
`static String` `IGNITE_MBEAN_APPEND_CLASS_LOADER_ID` If this property is set to `true` then Ignite will append hash code of class loader to MXBean name.
`static String` `IGNITE_MBEAN_APPEND_JVM_ID` If this property is set to `true` then Ignite will append hash code of `Ignite` class as hex string and append JVM name returned by `RuntimeMXBean.getName()`.
`static String` `IGNITE_MEMORY_PER_BYTE_COPY_THRESHOLD` When unsafe memory copy if performed below this threshold, Ignite will do it on per-byte basis instead of calling to Unsafe.copyMemory().
`static String` `IGNITE_MEMORY_UNALIGNED_ACCESS` Whether Ignite can access unaligned memory addresses.
`static String` `IGNITE_MIN_BUFFERED_COMMUNICATION_MSG_CNT` Deprecated. Not used anymore.
`static String` `IGNITE_NEAR_GET_MAX_REMAPS` This property defines the maximum number of attempts to remap near get to the same primary node.
`static String` `IGNITE_NO_ASCII` If this system property is present (any value) - no ASCII logo will be printed.
`static String` `IGNITE_NO_DISCO_ORDER` Name of the system property to disable requirement for proper node ordering by discovery SPI.
`static String` `IGNITE_NO_SELECTOR_OPTS` If set to `true`, then default selected keys set is used inside `GridNioServer` which lead to some extra garbage generation when processing selected keys.
`static String` `IGNITE_NO_SHUTDOWN_HOOK` If this system property is set to `false` - no shutdown hook will be set.
`static String` `IGNITE_OFFHEAP_SAFE_RELEASE` Flag that will force Ignite to fill memory block with some recognisable pattern right before this memory block is released.
`static String` `IGNITE_OPTIMIZED_MARSHALLER_USE_DEFAULT_SUID` Manages `OptimizedMarshaller` behavior of `serialVersionUID` computation for `Serializable` classes.
`static String` `IGNITE_OVERRIDE_MCAST_GRP` System property to override multicast group taken from configuration.
`static String` `IGNITE_PERFORMANCE_SUGGESTIONS_DISABLED` Flag indicating whether performance suggestions output on start should be disabled.
`static String` `IGNITE_PRELOAD_RESEND_TIMEOUT` System property to hold preload resend timeout for evicted partitions.
`static String` `IGNITE_PROG_NAME` Name of the system property defining name of command line program.
`static String` `IGNITE_QUIET` Set to either `true` or `false` to enable or disable quiet mode of Ignite.
`static String` `IGNITE_REFLECTION_CACHE_SIZE` System property to override default reflection cache size.
`static String` `IGNITE_REST_MAX_TASK_RESULTS` This property allows to override maximum count of task results stored on one node in REST processor.
`static String` `IGNITE_REST_SESSION_TIMEOUT` This property allow rewriting default (`30`) rest session expire time (in seconds).
`static String` `IGNITE_REST_START_ON_CLIENT` This property allows to override default behavior that rest processor doesn't start on client node.
`static String` `IGNITE_RESTART_CODE` This property is used internally to pass an exit code to loader when Ignite instance is being restarted.
`static String` `IGNITE_SERVICES_COMPATIBILITY_MODE` Manages backward compatibility of `IgniteServices`.
`static String` `IGNITE_SKIP_CONFIGURATION_CONSISTENCY_CHECK` Property allowing to skip configuration consistency checks.
`static String` `IGNITE_SLOW_TX_WARN_TIMEOUT` Transactions that take more time, than value of this property, will be output to log with warning level.
`static String` `IGNITE_SQL_MERGE_TABLE_MAX_SIZE` Property controlling maximum number of SQL result rows which can be fetched into a merge table.
`static String` `IGNITE_SQL_MERGE_TABLE_PREFETCH_SIZE` Property controlling number of SQL result rows that will be fetched into a merge table at once before applying binary search for the bounds.
`static String` `IGNITE_SSH_HOST` System property to hold SSH host for visor-started nodes.
`static String` `IGNITE_SSH_USER_NAME` System property to hold SSH user name for visor-started nodes.
`static String` `IGNITE_STARVATION_CHECK_INTERVAL` This system property defines interval in milliseconds in which Ignite will check thread pool state for starvation.
`static String` `IGNITE_SUCCESS_FILE` Name of the system property defining success file name.
`static String` `IGNITE_TCP_DISCOVERY_ADDRESSES` Comma separated list of addresses in format "10.100.22.100:45000,10.100.22.101:45000".
`static String` `IGNITE_THREAD_DUMP_ON_EXCHANGE_TIMEOUT` If this property is set to `true` then Ignite will log thread dump in case of partition exchange timeout.
`static String` `IGNITE_TO_STRING_INCLUDE_SENSITIVE` Setting to `true` enables writing sensitive information in `toString()` output.
`static String` `IGNITE_TX_DEADLOCK_DETECTION_MAX_ITERS` Specifies maximum number of iterations for deadlock detection procedure.
`static String` `IGNITE_TX_DEADLOCK_DETECTION_TIMEOUT` Specifies timeout for deadlock detection procedure.
`static String` `IGNITE_TX_SALVAGE_TIMEOUT` Timeout after which all uncompleted transactions originated by left node will be salvaged (i.e. invalidated and committed).
`static String` `IGNITE_UNWRAP_BINARY_FOR_INDEXING_SPI` Deprecated. Should be removed in Apache Ignite 2.0.
`static String` `IGNITE_UPDATE_NOTIFIER` If this system property is set to `false` - no checks for new versions will be performed by Ignite.
`static String` `IGNITE_WORK_DIR` Environment variable to set work directory.

### Method Summary

Methods
`static boolean` `getBoolean(String name)` Gets either system property or environment variable with given name.
`static boolean` `getBoolean(String name, boolean dflt)` Gets either system property or environment variable with given name.
`static double` `getDouble(String name, double dflt)` Gets either system property or environment variable with given name.
`static float` `getFloat(String name, float dflt)` Gets either system property or environment variable with given name.
`static int` `getInteger(String name, int dflt)` Gets either system property or environment variable with given name.
`static long` `getLong(String name, long dflt)` Gets either system property or environment variable with given name.
`static String` `getString(String name)` Gets either system property or environment variable with given name.
`static String` `getString(String name, String dflt)` Gets either system property or environment variable with given name.
`static Properties` `safeSnapshot()` Does the same as `snapshot()` but filters out possible sensitive user data.
`static Properties` `snapshot()` Gets snapshot of system properties.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### IGNITE_LOG_GRID_NAME

    @Deprecated
    public static final String IGNITE_LOG_GRID_NAME

Deprecated. Use `IGNITE_LOG_INSTANCE_NAME`.
If this system property is present the Ignite will include grid name into verbose log.

See Also:
  Constant Field Values

#### IGNITE_LOG_INSTANCE_NAME

    public static final String IGNITE_LOG_INSTANCE_NAME

If this system property is present the Ignite will include instance name into verbose log.

See Also:
  Constant Field Values

#### IGNITE_RESTART_CODE

    public static final String IGNITE_RESTART_CODE

This property is used internally to pass an exit code to loader when Ignite instance is being restarted.

See Also:
  Constant Field Values

#### IGNITE_DAEMON

    public static final String IGNITE_DAEMON

Presence of this system property with value `true` will make the grid node start as a daemon node. Node that this system property will override `IgniteConfiguration.isDaemon()` configuration.

See Also:
  Constant Field Values

#### IGNITE_HOME

    public static final String IGNITE_HOME

Defines Ignite installation folder.

See Also:
  Constant Field Values

#### IGNITE_NO_SHUTDOWN_HOOK

    public static final String IGNITE_NO_SHUTDOWN_HOOK

If this system property is set to `false` - no shutdown hook will be set.

See Also:
  Constant Field Values

#### IGNITE_NO_DISCO_ORDER

    public static final String IGNITE_NO_DISCO_ORDER

Name of the system property to disable requirement for proper node ordering by discovery SPI. Use with care, as proper node ordering is required for cache consistency. If set to `true`, then any discovery SPI can be used with distributed cache, otherwise, only discovery SPIs that have annotation `@GridDiscoverySpiOrderSupport(true)` will be allowed.

See Also:
  Constant Field Values

#### IGNITE_DISCO_FAILED_CLIENT_RECONNECT_DELAY

    public static final String IGNITE_DISCO_FAILED_CLIENT_RECONNECT_DELAY

Defines reconnect delay in milliseconds for client node that was failed forcible.

See Also:
  Constant Field Values

#### IGNITE_UPDATE_NOTIFIER

    public static final String IGNITE_UPDATE_NOTIFIER

If this system property is set to `false` - no checks for new versions will be performed by Ignite. By default, Ignite periodically checks for the new version and prints out the message into the log if new version of Ignite is available for download.

See Also:
  Constant Field Values

#### IGNITE_STARVATION_CHECK_INTERVAL

    public static final String IGNITE_STARVATION_CHECK_INTERVAL

This system property defines interval in milliseconds in which Ignite will check thread pool state for starvation. Zero value will disable this checker.

See Also:
  Constant Field Values

#### IGNITE_NO_ASCII

    public static final String IGNITE_NO_ASCII

If this system property is present (any value) - no ASCII logo will be printed.

See Also:
  Constant Field Values

#### IGNITE_JETTY_HOST

    public static final String IGNITE_JETTY_HOST

This property allows to override Jetty host for REST processor.

See Also:
  Constant Field Values

#### IGNITE_JETTY_PORT

    public static final String IGNITE_JETTY_PORT

This property allows to override Jetty local port for REST processor.

See Also:
  Constant Field Values

#### IGNITE_JETTY_LOG_NO_OVERRIDE

    public static final String IGNITE_JETTY_LOG_NO_OVERRIDE

This property does not allow Ignite to override Jetty log configuration for REST processor.

See Also:
  Constant Field Values

#### IGNITE_REST_SESSION_TIMEOUT

    public static final String IGNITE_REST_SESSION_TIMEOUT

This property allow rewriting default (`30`) rest session expire time (in seconds).

See Also:
  Constant Field Values

#### IGNITE_REST_MAX_TASK_RESULTS

    public static final String IGNITE_REST_MAX_TASK_RESULTS

This property allows to override maximum count of task results stored on one node in REST processor.

See Also:
  Constant Field Values

#### IGNITE_REST_START_ON_CLIENT

    public static final String IGNITE_REST_START_ON_CLIENT

This property allows to override default behavior that rest processor doesn't start on client node. If set `true` than rest processor will be started on client node.

See Also:
  Constant Field Values

#### IGNITE_NEAR_GET_MAX_REMAPS

    public static final String IGNITE_NEAR_GET_MAX_REMAPS

This property defines the maximum number of attempts to remap near get to the same primary node. Remapping may be needed when topology is changed concurrently with get operation.

See Also:
  Constant Field Values

#### IGNITE_QUIET

    public static final String IGNITE_QUIET

Set to either `true` or `false` to enable or disable quiet mode of Ignite. In quiet mode, only warning and errors are printed into the log additionally to a shortened version of standard output on the start.

Note that if you use `ignite.{sh|bat}` scripts to start Ignite they start by default in quiet mode. You can supply `-v` flag to override it.

See Also:
  Constant Field Values

#### IGNITE_TO_STRING_INCLUDE_SENSITIVE

    public static final String IGNITE_TO_STRING_INCLUDE_SENSITIVE

Setting to `true` enables writing sensitive information in `toString()` output.

See Also:
  Constant Field Values

#### IGNITE_CONSOLE_APPENDER

    public static final String IGNITE_CONSOLE_APPENDER

If this property is set to `true` (default) and Ignite is launched in verbose mode (see `IGNITE_QUIET`) and no console appenders can be found in configuration, then default console appender will be added. Set this property to `false` if no appenders should be added.

See Also:
  Constant Field Values

#### IGNITE_PROG_NAME

    public static final String IGNITE_PROG_NAME

Name of the system property defining name of command line program.

See Also:
  Constant Field Values

#### IGNITE_SUCCESS_FILE

    public static final String IGNITE_SUCCESS_FILE

Name of the system property defining success file name. This file is used with auto-restarting functionality when Ignite is started by supplied `ignite.{bat|sh}` scripts.

See Also:
  Constant Field Values

#### IGNITE_LOCAL_HOST

    public static final String IGNITE_LOCAL_HOST

Name of system property to set system-wide local IP address or host. If provided it will override all default local bind settings within Ignite or any of its SPIs.

Note that system-wide local bind address can also be set via `IgniteConfiguration.getLocalHost()` method. However, system properties have priority over configuration properties specified in `IgniteConfiguration`.

See Also:
  Constant Field Values

#### IGNITE_DEP_MODE_OVERRIDE

    public static final String IGNITE_DEP_MODE_OVERRIDE

System property to override deployment mode configuration parameter. Valid values for property are: PRIVATE, ISOLATED, SHARED or CONTINUOUS.

See Also:
  `DeploymentMode`, `IgniteConfiguration.getDeploymentMode()`, Constant Field Values

#### IGNITE_MAX_COMPLETED_TX_COUNT

    public static final String IGNITE_MAX_COMPLETED_TX_COUNT

Property controlling size of buffer holding completed transaction versions. Such buffer is used to detect duplicate transaction and has a default value of `102400`. In most cases this value is large enough and does not need to be changed.

See Also:
  Constant Field Values

#### IGNITE_MAP_CONCURRENCY_LEVEL

    public static final String IGNITE_MAP_CONCURRENCY_LEVEL

Concurrency level for all concurrent hash maps created by Ignite.

See Also:
  Constant Field Values

#### IGNITE_SLOW_TX_WARN_TIMEOUT

    public static final String IGNITE_SLOW_TX_WARN_TIMEOUT

Transactions that take more time, than value of this property, will be output to log with warning level. `0` (default value) disables warning on slow transactions.

See Also:
  Constant Field Values

#### IGNITE_TX_SALVAGE_TIMEOUT

    public static final String IGNITE_TX_SALVAGE_TIMEOUT

Timeout after which all uncompleted transactions originated by left node will be salvaged (i.e. invalidated and committed).

See Also:
  Constant Field Values

#### IGNITE_TX_DEADLOCK_DETECTION_MAX_ITERS

    public static final String IGNITE_TX_DEADLOCK_DETECTION_MAX_ITERS

Specifies maximum number of iterations for deadlock detection procedure. If value of this property is less then or equal to zero then deadlock detection will be disabled.

See Also:
  Constant Field Values

#### IGNITE_TX_DEADLOCK_DETECTION_TIMEOUT

    public static final String IGNITE_TX_DEADLOCK_DETECTION_TIMEOUT

Specifies timeout for deadlock detection procedure.

See Also:
  Constant Field Values

#### IGNITE_OVERRIDE_MCAST_GRP

    public static final String IGNITE_OVERRIDE_MCAST_GRP

System property to override multicast group taken from configuration. Used for testing purposes.

See Also:
  Constant Field Values

#### IGNITE_REFLECTION_CACHE_SIZE

    public static final String IGNITE_REFLECTION_CACHE_SIZE

System property to override default reflection cache size. Default value is `128`.

See Also:
  Constant Field Values

#### IGNITE_JOBS_HISTORY_SIZE

    public static final String IGNITE_JOBS_HISTORY_SIZE

System property to override default job processor maps sizes for finished jobs and cancellation requests. Default value is `10240`.

See Also:
  Constant Field Values

#### IGNITE_JOBS_METRICS_CONCURRENCY_LEVEL

    public static final String IGNITE_JOBS_METRICS_CONCURRENCY_LEVEL

System property to override default job metrics processor property defining concurrency level for structure holding job metrics snapshots. Default value is `64`.

See Also:
  Constant Field Values

#### IGNITE_CONFIG_URL

    public static final String IGNITE_CONFIG_URL

System property to hold optional configuration URL.

See Also:
  Constant Field Values

#### IGNITE_SSH_HOST

    public static final String IGNITE_SSH_HOST

System property to hold SSH host for visor-started nodes.

See Also:
  Constant Field Values

#### IGNITE_SSH_USER_NAME

    public static final String IGNITE_SSH_USER_NAME

System property to hold SSH user name for visor-started nodes.

See Also:
  Constant Field Values

#### IGNITE_PRELOAD_RESEND_TIMEOUT

    public static final String IGNITE_PRELOAD_RESEND_TIMEOUT

System property to hold preload resend timeout for evicted partitions.

See Also:
  Constant Field Values

#### IGNITE_MARSHAL_BUFFERS_RECHECK

    public static final String IGNITE_MARSHAL_BUFFERS_RECHECK

System property to specify how often in milliseconds marshal buffers should be rechecked and potentially trimmed. Default value is `10,000ms`.

See Also:
  Constant Field Values

#### IGNITE_DISABLE_HOSTNAME_VERIFIER

    public static final String IGNITE_DISABLE_HOSTNAME_VERIFIER

System property to disable `HostnameVerifier` for SSL connections. Can be used for development with self-signed certificates. Default value is `false`.

See Also:
  Constant Field Values

#### IGNITE_MIN_BUFFERED_COMMUNICATION_MSG_CNT

    @Deprecated
    public static final String IGNITE_MIN_BUFFERED_COMMUNICATION_MSG_CNT

Deprecated. Not used anymore.
System property to disable buffered communication if node sends less messages count than specified by this property. Default value is `512`.

See Also:
  Constant Field Values

#### IGNITE_OFFHEAP_SAFE_RELEASE

    public static final String IGNITE_OFFHEAP_SAFE_RELEASE

Flag that will force Ignite to fill memory block with some recognisable pattern right before this memory block is released. This will help to recognize cases when already released memory is accessed.

See Also:
  Constant Field Values

#### IGNITE_ATOMIC_CACHE_DELETE_HISTORY_SIZE

    public static final String IGNITE_ATOMIC_CACHE_DELETE_HISTORY_SIZE

Maximum size for atomic cache queue delete history (default is 200 000 entries per partition).

See Also:
  Constant Field Values

#### IGNITE_ATOMIC_CACHE_MAX_CONCURRENT_DHT_UPDATES

    public static final String IGNITE_ATOMIC_CACHE_MAX_CONCURRENT_DHT_UPDATES

Maximum amount of concurrent updates per system thread in atomic caches in case of PRIMARY_SYNC or FULL_ASYNC write synchronization mode. If this limit is exceeded then update will be performed with FULL_SYNC synchronization mode. If value is `0` then limit is unbounded.

See Also:
  Constant Field Values

#### IGNITE_CACHE_REMOVED_ENTRIES_TTL

    public static final String IGNITE_CACHE_REMOVED_ENTRIES_TTL

Ttl of removed cache entries (ms).

See Also:
  Constant Field Values

#### IGNITE_TCP_DISCOVERY_ADDRESSES

    public static final String IGNITE_TCP_DISCOVERY_ADDRESSES

Comma separated list of addresses in format "10.100.22.100:45000,10.100.22.101:45000". Makes sense only for `TcpDiscoveryVmIpFinder`.

See Also:
  Constant Field Values

#### IGNITE_PERFORMANCE_SUGGESTIONS_DISABLED

    public static final String IGNITE_PERFORMANCE_SUGGESTIONS_DISABLED

Flag indicating whether performance suggestions output on start should be disabled.

See Also:
  Constant Field Values

#### IGNITE_ATOMIC_DEFERRED_ACK_BUFFER_SIZE

    public static final String IGNITE_ATOMIC_DEFERRED_ACK_BUFFER_SIZE

Atomic cache deferred update response buffer size.

See Also:
  Constant Field Values

#### IGNITE_ATOMIC_DEFERRED_ACK_TIMEOUT

    public static final String IGNITE_ATOMIC_DEFERRED_ACK_TIMEOUT

Atomic cache deferred update timeout.

See Also:
  Constant Field Values

#### IGNITE_DEFERRED_ONE_PHASE_COMMIT_ACK_REQUEST_TIMEOUT

    public static final String IGNITE_DEFERRED_ONE_PHASE_COMMIT_ACK_REQUEST_TIMEOUT

One phase commit deferred ack request timeout.

See Also:
  Constant Field Values

#### IGNITE_DEFERRED_ONE_PHASE_COMMIT_ACK_REQUEST_BUFFER_SIZE

    public static final String IGNITE_DEFERRED_ONE_PHASE_COMMIT_ACK_REQUEST_BUFFER_SIZE

One phase commit deferred ack request buffer size.

See Also:
  Constant Field Values

#### IGNITE_H2_DEBUG_CONSOLE

    public static final String IGNITE_H2_DEBUG_CONSOLE

If this property set then debug console will be opened for H2 indexing SPI.

See Also:
  Constant Field Values

#### IGNITE_H2_DEBUG_CONSOLE_PORT

    public static final String IGNITE_H2_DEBUG_CONSOLE_PORT

This property allows to specify user defined port which H2 indexing SPI will use to start H2 debug console on. If this property is not set or set to 0, H2 debug console will use system-provided dynamic port. This property is only relevant when `IGNITE_H2_DEBUG_CONSOLE` property is set.

See Also:
  Constant Field Values

#### IGNITE_IPC_SHMEM_SPACE_DEBUG

    public static final String IGNITE_IPC_SHMEM_SPACE_DEBUG

If this property is set to `true` then shared memory space native debug will be enabled.

See Also:
  Constant Field Values

#### IGNITE_SKIP_CONFIGURATION_CONSISTENCY_CHECK

    public static final String IGNITE_SKIP_CONFIGURATION_CONSISTENCY_CHECK

Property allowing to skip configuration consistency checks.

See Also:
  Constant Field Values

#### IGNITE_CACHE_KEY_VALIDATION_DISABLED

    public static final String IGNITE_CACHE_KEY_VALIDATION_DISABLED

Flag indicating whether validation of keys put to cache should be disabled.

See Also:
  Constant Field Values

#### IGNITE_LOG_DIR

    public static final String IGNITE_LOG_DIR

Environment variable to override logging directory that has been set in logger configuration.

See Also:
  Constant Field Values

#### IGNITE_WORK_DIR

    public static final String IGNITE_WORK_DIR

Environment variable to set work directory. The property `IgniteConfiguration.setWorkDirectory(java.lang.String)` has higher priority.

See Also:
  Constant Field Values

#### IGNITE_MBEAN_APPEND_JVM_ID

    public static final String IGNITE_MBEAN_APPEND_JVM_ID

If this property is set to `true` then Ignite will append hash code of `Ignite` class as hex string and append JVM name returned by `RuntimeMXBean.getName()`.

This may be helpful when running Ignite in some application server clusters or similar environments to avoid MBean name collisions.

Default is `false`.

See Also:
  Constant Field Values

#### IGNITE_MBEAN_APPEND_CLASS_LOADER_ID

    public static final String IGNITE_MBEAN_APPEND_CLASS_LOADER_ID

If this property is set to `true` then Ignite will append hash code of class loader to MXBean name.

Default is `true`.

See Also:
  Constant Field Values

#### IGNITE_EXCEPTION_REGISTRY_MAX_SIZE

    public static final String IGNITE_EXCEPTION_REGISTRY_MAX_SIZE

Property controlling size of buffer holding last exception. Default value of `1000`.

See Also:
  Constant Field Values

#### IGNITE_CACHE_CLIENT

    public static final String IGNITE_CACHE_CLIENT

Property controlling default behavior of cache client flag.

See Also:
  Constant Field Values

#### IGNITE_JCACHE_DEFAULT_ISOLATED

    public static final String IGNITE_JCACHE_DEFAULT_ISOLATED

Property controlling whether CacheManager will start grid with isolated IP finder when default URL is passed in. This is needed to pass TCK tests which use default URL and assume isolated cache managers for different class loaders.

See Also:
  Constant Field Values

#### IGNITE_SQL_MERGE_TABLE_MAX_SIZE

    public static final String IGNITE_SQL_MERGE_TABLE_MAX_SIZE

Property controlling maximum number of SQL result rows which can be fetched into a merge table. If there are less rows than this threshold then multiple passes throw a table will be possible, otherwise only one pass (e.g. only result streaming is possible).

See Also:
  Constant Field Values

#### IGNITE_SQL_MERGE_TABLE_PREFETCH_SIZE

    public static final String IGNITE_SQL_MERGE_TABLE_PREFETCH_SIZE

Property controlling number of SQL result rows that will be fetched into a merge table at once before applying binary search for the bounds.

See Also:
  Constant Field Values

#### IGNITE_AFFINITY_HISTORY_SIZE

    public static final String IGNITE_AFFINITY_HISTORY_SIZE

Maximum size for affinity assignment history.

See Also:
  Constant Field Values

#### IGNITE_DISCOVERY_HISTORY_SIZE

    public static final String IGNITE_DISCOVERY_HISTORY_SIZE

Maximum size for discovery messages history.

See Also:
  Constant Field Values

#### IGNITE_DISCOVERY_CLIENT_RECONNECT_HISTORY_SIZE

    public static final String IGNITE_DISCOVERY_CLIENT_RECONNECT_HISTORY_SIZE

Maximum number of discovery message history used to support client reconnect.

See Also:
  Constant Field Values

#### IGNITE_CACHE_RETRIES_COUNT

    public static final String IGNITE_CACHE_RETRIES_COUNT

Number of cache operation retries in case of topology exceptions.

See Also:
  Constant Field Values

#### IGNITE_DUMP_PENDING_OBJECTS_THRESHOLD

    public static final String IGNITE_DUMP_PENDING_OBJECTS_THRESHOLD

Number of times pending cache objects will be dumped to the log in case of partition exchange timeout.

See Also:
  Constant Field Values

#### IGNITE_THREAD_DUMP_ON_EXCHANGE_TIMEOUT

    public static final String IGNITE_THREAD_DUMP_ON_EXCHANGE_TIMEOUT

If this property is set to `true` then Ignite will log thread dump in case of partition exchange timeout.

See Also:
  Constant Field Values

#### IGNITE_LONG_OPERATIONS_DUMP_TIMEOUT

    public static final String IGNITE_LONG_OPERATIONS_DUMP_TIMEOUT

Cache operations that take more time than value of this property will be output to log. Set to `0` to disable.

See Also:
  Constant Field Values

#### IGNITE_JDBC_DRIVER_CURSOR_REMOVE_DELAY

    public static final String IGNITE_JDBC_DRIVER_CURSOR_REMOVE_DELAY

JDBC driver cursor remove delay.

See Also:
  Constant Field Values

#### IGNITE_LONG_LONG_HASH_MAP_LOAD_FACTOR

    public static final String IGNITE_LONG_LONG_HASH_MAP_LOAD_FACTOR

Long-long offheap map load factor.

See Also:
  Constant Field Values

#### IGNITE_MAX_NESTED_LISTENER_CALLS

    public static final String IGNITE_MAX_NESTED_LISTENER_CALLS

Maximum number of nested listener calls before listener notification becomes asynchronous.

See Also:
  Constant Field Values

#### IGNITE_LOCAL_STORE_KEEPS_PRIMARY_ONLY

    public static final String IGNITE_LOCAL_STORE_KEEPS_PRIMARY_ONLY

Indicating whether local store keeps primary only. Backward compatibility flag.

See Also:
  Constant Field Values

#### IGNITE_OPTIMIZED_MARSHALLER_USE_DEFAULT_SUID

    public static final String IGNITE_OPTIMIZED_MARSHALLER_USE_DEFAULT_SUID

Manages `OptimizedMarshaller` behavior of `serialVersionUID` computation for `Serializable` classes.

See Also:
  Constant Field Values

#### IGNITE_BINARY_MARSHALLER_USE_STRING_SERIALIZATION_VER_2

    public static final String IGNITE_BINARY_MARSHALLER_USE_STRING_SERIALIZATION_VER_2

Manages type of serialization mechanism for `String` that is marshalled/unmarshalled by BinaryMarshaller. Should be used for cases when a String contains a surrogate symbol without its pair one. This is frequently used in algorithms that encrypts data in String format.

See Also:
  Constant Field Values

#### IGNITE_NO_SELECTOR_OPTS

    public static final String IGNITE_NO_SELECTOR_OPTS

If set to `true`, then default selected keys set is used inside `GridNioServer` which lead to some extra garbage generation when processing selected keys.

Default value is `false`. Should be switched to `true` if there are any problems in communication layer.

See Also:
  Constant Field Values

#### IGNITE_H2_INDEXING_CACHE_CLEANUP_PERIOD

    public static final String IGNITE_H2_INDEXING_CACHE_CLEANUP_PERIOD

System property to specify period in milliseconds between calls of the SQL statements cache cleanup task.

Cleanup tasks clears cache for terminated threads and for threads which did not perform SQL queries within timeout configured via `IGNITE_H2_INDEXING_CACHE_THREAD_USAGE_TIMEOUT` property.

Default value is `10,000ms`.

See Also:
  Constant Field Values

#### IGNITE_H2_INDEXING_CACHE_THREAD_USAGE_TIMEOUT

    public static final String IGNITE_H2_INDEXING_CACHE_THREAD_USAGE_TIMEOUT

System property to specify timeout in milliseconds after which thread's SQL statements cache is cleared by cleanup task if the thread does not perform any query.

Default value is `600,000ms`.

See Also:
  Constant Field Values

#### IGNITE_SERVICES_COMPATIBILITY_MODE

    public static final String IGNITE_SERVICES_COMPATIBILITY_MODE

Manages backward compatibility of `IgniteServices`. All nodes in cluster must have identical value of this property.

If property is `false` then node is not required to have service implementation class if service is not deployed on this node.

If the property is `true` then service implementation class is required on node even if service is not deployed on this node.

If the property is not set (`null`) then Ignite will automatically detect which compatibility mode should be used.

See Also:
  Constant Field Values

#### IGNITE_BINARY_DONT_WRAP_TREE_STRUCTURES

    @Deprecated
    public static final String IGNITE_BINARY_DONT_WRAP_TREE_STRUCTURES

Deprecated. Should be removed in Apache Ignite 2.0.
When set to `true` tree-based data structures - `TreeMap` and `TreeSet` - will not be wrapped into special holders introduced to overcome serialization issue caused by missing `Comparable` interface on `BinaryObject`.

See Also:
  Constant Field Values

#### IGNITE_CONSISTENT_ID_BY_HOST_WITHOUT_PORT

    public static final String IGNITE_CONSISTENT_ID_BY_HOST_WITHOUT_PORT

When set to `true`, for consistent id will calculate by host name, without port, and you can use only one node for host in cluster.

See Also:
  Constant Field Values

#### IGNITE_IO_BALANCE_PERIOD

    public static final String IGNITE_IO_BALANCE_PERIOD

See Also:
  Constant Field Values

#### IGNITE_BINARY_SORT_OBJECT_FIELDS

    @Deprecated
    public static final String IGNITE_BINARY_SORT_OBJECT_FIELDS

Deprecated. Should be removed in Apache Ignite 2.0.
When set to `true` fields are written by BinaryMarshaller in sorted order. Otherwise the natural order is used.

See Also:
  Constant Field Values

#### IGNITE_MEMORY_UNALIGNED_ACCESS

    public static final String IGNITE_MEMORY_UNALIGNED_ACCESS

Whether Ignite can access unaligned memory addresses.

Defaults to `` false, meaning that unaligned access will be performed only on x86 architecture.

See Also:
  Constant Field Values

#### IGNITE_MEMORY_PER_BYTE_COPY_THRESHOLD

    public static final String IGNITE_MEMORY_PER_BYTE_COPY_THRESHOLD

When unsafe memory copy if performed below this threshold, Ignite will do it on per-byte basis instead of calling to Unsafe.copyMemory().

Defaults to 0, meaning that threshold is disabled.

See Also:
  Constant Field Values

#### IGNITE_UNWRAP_BINARY_FOR_INDEXING_SPI

    public static final String IGNITE_UNWRAP_BINARY_FOR_INDEXING_SPI

Deprecated. Should be removed in Apache Ignite 2.0.
When set to `true` BinaryObject will be unwrapped before passing to IndexingSpi to preserve old behavior query processor with IndexingSpi.

See Also:
  Constant Field Values

#### IGNITE_MAX_INDEX_PAYLOAD_SIZE

    public static final String IGNITE_MAX_INDEX_PAYLOAD_SIZE

System property to specify maximum payload size in bytes for `H2TreeIndex`.

Defaults to `0`, meaning that inline index store is disabled.

See Also:
  Constant Field Values

#### IGNITE_INDEXING_DISCOVERY_HISTORY_SIZE

    public static final String IGNITE_INDEXING_DISCOVERY_HISTORY_SIZE

Indexing discovery history size. Protects from duplicate messages maintaining the list of IDs of recently arrived discovery messages.

Defaults to `1000`.

See Also:
  Constant Field Values

#### IGNITE_CACHE_START_SIZE

    public static final String IGNITE_CACHE_START_SIZE

Cache start size for on-heap maps. Defaults to 4096.

See Also:
  Constant Field Values

### Method Detail

#### getString

    @Nullable
    public static String getString(String name)

Gets either system property or environment variable with given name.

Parameters:
  `name` - Name of the system property or environment variable.
Returns:
  Value of the system property or environment variable. Returns `null` if neither can be found for given name.

#### getString

    @Nullable
    public static String getString(String name,
                            String dflt)

Gets either system property or environment variable with given name.

Parameters:
  `name` - Name of the system property or environment variable.
  `dflt` - Default value.
Returns:
  Value of the system property or environment variable. Returns `null` if neither can be found for given name.

#### getBoolean

    public static boolean getBoolean(String name)

Gets either system property or environment variable with given name. The result is transformed to `boolean` using `Boolean.valueOf()` method.

Parameters:
  `name` - Name of the system property or environment variable.
Returns:
  Boolean value of the system property or environment variable. Returns `False` in case neither system property nor environment variable with given name is found.

#### getBoolean

    public static boolean getBoolean(String name,
                     boolean dflt)

Gets either system property or environment variable with given name. The result is transformed to `boolean` using `Boolean.valueOf()` method.

Parameters:
  `name` - Name of the system property or environment variable.
  `dflt` - Default value.
Returns:
  Boolean value of the system property or environment variable. Returns default value in case neither system property nor environment variable with given name is found.

#### getInteger

    public static int getInteger(String name,
                 int dflt)

Gets either system property or environment variable with given name. The result is transformed to `int` using `Integer.parseInt()` method.

Parameters:
  `name` - Name of the system property or environment variable.
  `dflt` - Default value
Returns:
  Integer value of the system property or environment variable. Returns default value in case neither system property nor environment variable with given name is found.

#### getFloat

    public static float getFloat(String name,
                 float dflt)

Gets either system property or environment variable with given name. The result is transformed to `float` using `Float.parseFloat()` method.

Parameters:
  `name` - Name of the system property or environment variable.
  `dflt` - Default value
Returns:
  Float value of the system property or environment variable. Returns default value in case neither system property nor environment variable with given name is found.

#### getLong

    public static long getLong(String name,
               long dflt)

Gets either system property or environment variable with given name. The result is transformed to `long` using `Long.parseLong()` method.

Parameters:
  `name` - Name of the system property or environment variable.
  `dflt` - Default value
Returns:
  Integer value of the system property or environment variable. Returns default value in case neither system property nor environment variable with given name is found.

#### getDouble

    public static double getDouble(String name,
                   double dflt)

Gets either system property or environment variable with given name. The result is transformed to `double` using `Double.parseDouble()` method.

Parameters:
  `name` - Name of the system property or environment variable.
  `dflt` - Default value
Returns:
  Integer value of the system property or environment variable. Returns default value in case neither system property nor environment variable with given name is found.

#### snapshot

    public static Properties snapshot()

Gets snapshot of system properties. Snapshot could be used for thread safe iteration over system properties. Non-string properties are removed before return.

Returns:
  Snapshot of system properties.

#### safeSnapshot

    public static Properties safeSnapshot()

Does the same as `snapshot()` but filters out possible sensitive user data.

Returns:
  Snapshot of system properties.

2017 Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Fabric | : ver. 2.0.0
Release Date | : April 30 2017